package geniusweb.protocol.tournament.allpermutationslearn;

import java.util.ArrayList;
import java.util.List;

import geniusweb.protocol.session.SessionResult;
import geniusweb.protocol.session.SessionSettings;
import geniusweb.protocol.tournament.allpermutations.AllPermutationsState;
import tudelft.utilities.immutablelist.ImmutableList;

/**
 * A non-parallel simple implementation of all-permutations
 */
public class AllPermutationsLearnState extends AllPermutationsState {

	public AllPermutationsLearnState(AllPermutationsLearnSettings toursettings,
			ImmutableList<SessionSettings> settings,
			List<SessionResult> results) {
		super(toursettings, settings, results);
	}

	/**
	 * 
	 * @param result the next {@link SessionResult}
	 * @return new state
	 * @throws IllegalArgumentException if the result participants are not
	 *                                  matching the expected participants
	 */
	@Override
	public AllPermutationsLearnState with(SessionResult result) {
		ArrayList<SessionResult> newresults = new ArrayList<>(results);
		newresults.add(result);
		return new AllPermutationsLearnState(
				(AllPermutationsLearnSettings) toursettings, sessionsettings,
				newresults);
	}

}
